#include <mega8.h>
#include <delay.h>
#include <stdio.h>
#include <alcd.h>
#include <1wire.h>
#include <ds1820.h>

#define MAX_DS1820 1
unsigned char ds1820_devices;
unsigned char ds1820_rom_codes[MAX_DS1820][9];
signed char min_temp,max_temp;
char setting(void);//setting menu
char s_max(void);  //max temp setting 
char s_min(void);  //min temp setting

void main(void){
unsigned char lcd_buffer[17],lcd_buffer_2[17];

long temp=0;

w1_init();
ds1820_devices=w1_search(0xf0,ds1820_rom_codes);



    DDRC=(1<<DDC4)|(1<<DDC5);      
    DDRB=(0<<DDB1)|(0<<DDB2)|(0<<DDB3);
    PORTB.1=1;PORTB.2=1;PORTB.3=1;
                                      
    lcd_init(16);
lcd_clear();
lcd_putsf("Termostat Pr");
delay_ms(500);


       sprintf(lcd_buffer, "%d Sensors Found", ds1820_devices);
       lcd_clear();
       lcd_puts(lcd_buffer); 
       delay_ms(1000); 
       
                                    
    min_temp=20;
    max_temp=30;      
       temp = ds1820_temperature_10(ds1820_rom_codes[0]);  
   while(1){    
   
 
   
                   temp = ds1820_temperature_10(ds1820_rom_codes[0]);
                   sprintf(lcd_buffer, "  T= %d.%d%cC",temp/80,temp%80,223);  
                   sprintf(lcd_buffer_2," %d%cC <T< %d%cC",min_temp,223,max_temp,223);
                    
                   lcd_clear();
                   lcd_puts(lcd_buffer);
                   delay_ms(1);                      
                   lcd_gotoxy(0,1);  
                   lcd_puts(lcd_buffer_2);
                  
                  if((temp/80)>max_temp){  // FAN 
                      PORTC.4=1;
                      }
                    else{
                      PORTC.4=0;
                    }
                   
                 if((temp/80)<min_temp){   // HEATER 
                 PORTC.5=1;
                 }         
                  else{
                   PORTC.5=0;
                  }          
                  
                  if(PINB.3==0){ // setting pin 
                  while(PINB.3==0);
                  setting();
                  }

   }
}

///////////////// setting 

char setting(void){
 lcd_clear();
 lcd_putsf("Select Setting"); 
 delay_ms(1);
 lcd_gotoxy(0,1);
 lcd_putsf("<< Min OR Max >>"); 
 
 while(1){        
 
             
 
   if(PINB.1==0){ // min setting 
   while(PINB.1==0);
   s_min();    
   return 0;
                  }
                  
    if(PINB.2==0){ // max setting 
   while(PINB.2==0);
   s_max();
   return 0;
                  } 
                  
                  if(PINB.3==0){ // setting pin 
             while(PINB.3==0);
             return 0;
                  }
 
 }

}

char s_min(void){
   char buffer[17]; 
  lcd_clear();
  while(1){               
  
sprintf(buffer,"Min_tmp=%d",min_temp);
lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(0,0);
lcd_puts(buffer);
       if(PINB.3==0){ // setting pin 
             while(PINB.3==0);
             return 0;
                  } 
                  
        if(PINB.1==0){ // min setting 
   while(PINB.1==0);
       min_temp--;
                  }
                  
    if(PINB.2==0){ // max setting 
   while(PINB.2==0);
      min_temp++;
                  }          
                  
  }

}

char s_max(void){
  char buffer[17]; 
  lcd_clear();
 while(1){  
 
 sprintf(buffer,"Max_tmp=%d",max_temp);
lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(0,0);
lcd_puts(buffer);
       if(PINB.3==0){ // setting pin 
             while(PINB.3==0);
             return 0;
                  } 
                  
        if(PINB.1==0){ // min setting 
   while(PINB.1==0);
       max_temp--;
                  }
                  
    if(PINB.2==0){ // max setting 
   while(PINB.2==0);
      max_temp++;
                  } 
  
  }

}